unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls,

  uDaten, utime;

type
  TForm1 = class(TForm)
    i_base: TImage;
    b_showgrid: TButton;
    l_koor: TLabel;
    Label1: TLabel;
    i_pipes: TImage;
    Button1: TButton;
    l_ablauf: TLabel;
    b_fluss: TButton;
    tb_delay: TTrackBar;
    b_automatic: TButton;
    b_bruteforce: TButton;
    m_debug: TMemo;
    cb_wait: TCheckBox;
    cb_show: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure b_showgridClick(Sender: TObject);
    procedure i_baseMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure i_pipesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure i_pipesMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; vp_X, vp_Y: Integer);
    procedure b_showpipesClick(Sender: TObject);
    procedure i_pipesContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure b_flussClick(Sender: TObject);
    procedure b_automaticClick(Sender: TObject);
    procedure b_bruteforceClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

var
  v_xspace: integer = 1;
  v_yspace: integer = 1;
  v_xofs, v_yofs:integer;

  v_orientation: integer=4;
  v_xold, v_yold: integer;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  v_xspace:= 400 div (c_xwide+1);
  v_xofs:= v_xspace div 2;
  v_yspace := 400 div c_ywide;
  v_yofs:= v_yspace div 2;
  v_ablaufx:=2;
  v_ablaufy:=2;

  with i_base.picture.bitmap do begin
    create;
    width:=i_base.width;
    height:=i_base.height;
  end;
  with i_pipes.picture.bitmap do begin
    create;
    width:=i_base.width;
    height:=i_base.height;
  end;
end;

procedure TForm1.b_showgridClick(Sender: TObject);
var
  vp_xrun, vp_yrun: integer;
begin
  v_xspace:= 400 div (c_xwide+1);
  v_xofs:= v_xspace div 2;
  v_yspace := 400 div c_ywide;
  v_yofs:= v_yspace div 2;
  i_base.Picture.Bitmap.Canvas.Pen.color:=clred;
  for vp_yrun:=1 to c_ywide do
    begin
      with i_base.Picture.Bitmap.Canvas do begin
        MoveTo(0,(vp_yrun-1)*(400 div c_ywide));
        LineTo(400,(vp_yrun-1)*(400 div c_ywide));
        for vp_xrun:=1 to c_xwide do begin
          textout((vp_xrun)*(400 div(c_xwide+1)),(vp_yrun)*(400 div c_ywide)-(200 div c_ywide),inttostr(vp_xrun)+'; '+inttostr(vp_yrun));
          if (vp_xrun+vp_yrun) mod 2= 0 then begin
            MoveTo((vp_xrun-1)*(400 div (c_xwide+1)),vp_yrun*(400 div c_ywide));
            LineTo((vp_xrun)*(400 div(c_xwide+1)),(vp_yrun-1)*(400 div c_ywide));
            LineTo((vp_xrun+1)*(400 div (c_xwide+1)),(vp_yrun)*(400 div c_ywide));
          end
          else
          begin
            MoveTo((vp_xrun-1)*(400 div (c_xwide+1)),(vp_yrun-1)*(400 div c_ywide));
            LineTo((vp_xrun)*(400 div (c_xwide+1)),(vp_yrun)*(400 div c_ywide));
            LineTo((vp_xrun+1)*(400 div (c_xwide+1)),(vp_yrun-1)*(400 div c_ywide));
          end;
        end;
      end;
    end; // for vp_yrun:=0 to c_ywide do


end;

function getscrx(vp_x:integer):integer;
begin
  getscrx:=vp_x*v_xspace;
end;

function getscry(vp_y:integer):integer;
begin
  getscry:=vp_y*v_yspace-v_yofs;
end;


function getx(x,y:integer):integer;
var
  vp_x,vp_y,vp_x0space:integer;

begin
  vp_y:=1+(y div v_yspace);
  if vp_y mod 2=0
    then vp_x0space:=round(v_xspace * (y mod v_yspace)/v_yspace)
    else vp_x0space:=v_xspace-round(v_xspace * (y mod v_yspace)/v_yspace);
  vp_x:=0;
  x:=x-vp_x0space;
  repeat
    inc(vp_x);
    if vp_x mod 2= 1
      then x:=x-(2*(v_xspace-vp_x0space))
      else x:=x-(2*vp_x0space);
  until x<0;
  getx:=vp_x;
end;

function gety(vp_y:integer):integer;
begin
  gety:=1+(vp_y div v_yspace);
end;

procedure TForm1.i_baseMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if v_yspace>0 then 
  l_koor.caption:='x: '+inttostr(getx(x,y))+' Y: '+inttostr(1+(y div v_yspace))+ ' Fluss: '+inttostr(v_data[getx(x,y),gety(y)].fluss);
end;

procedure TForm1.i_pipesMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  v_xold:=getx(x,y);
  v_yold:=1+(y div v_yspace);
end;

procedure TForm1.i_pipesMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; vp_X, vp_Y: Integer);
begin
  connect(koordinaten(v_xold,v_yold),koordinaten(getx(vp_x,vp_y),gety(vp_y)));

end;

procedure TForm1.b_showpipesClick(Sender: TObject);
var
  vp_xrun, vp_yrun: integer;
begin
  with i_pipes.Picture.Bitmap.Canvas do
    begin
      brush.color:=clwhite;
      fillrect(rect(0,0,400,400));
      pen.color:=clblue;
    end;
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:=1 to c_xwide do
      if not((vp_xrun=v_ablaufx)and(vp_yrun=v_ablaufy))
      then
        with i_pipes.Picture.Bitmap.Canvas do
          begin
            moveto(getscrx(v_data[vp_xrun,vp_yrun].x), getscry(v_data[vp_xrun,vp_yrun].y));
            lineto((getscrx(v_data[vp_xrun,vp_yrun].x)+getscrx(vp_xrun)+getscrx(vp_xrun)+getscrx(vp_xrun))div 4,
                   (getscry(v_data[vp_xrun,vp_yrun].y)+getscry(vp_yrun)+getscry(vp_yrun)+getscry(vp_yrun))div 4);
          end;
  i_pipes.Repaint;
//  showmessage('Repaint');
end;

procedure TForm1.i_pipesContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  v_ablaufx:=getx(Mousepos.x,Mousepos.y);
  v_ablaufy:=gety(Mousepos.y);
  l_ablauf.Caption:='Ablauf: '+inttostr(v_ablaufx)+'; '+inttostr(v_ablaufy);
end;

procedure TForm1.b_flussClick(Sender: TObject);
var
  vp_xrun, vp_yrun:integer;
begin
  label1.Caption:='Summe: '+inttostr(calcfluss);
  // Show
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      begin
        i_base.Picture.Bitmap.Canvas.Brush.Color:= $10000*v_data[vp_xrun,vp_yrun].fluss{*tb_delay.Position};
        i_base.Picture.Bitmap.Canvas.FloodFill(getscrx(vp_xrun),getscry(vp_yrun),clred,fsBorder);
      end;

  label1.Caption:='Disp.: '+floattostr(calcdisp);
  i_base.Picture.Bitmap.Canvas.Brush.Color:= clgreen;
  i_base.Picture.Bitmap.Canvas.FloodFill(getscrx(v_ablaufx),getscry(v_ablaufy),clred,fsBorder);
end;

procedure TForm1.b_automaticClick(Sender: TObject);

  function pconnectpossible(vp_pos:tpoint):boolean;
  begin
    if (0<vp_pos.x)and(vp_pos.x<=c_xwide)
       and(0<vp_pos.y)and(vp_pos.y<=c_ywide)
       and(v_data[vp_pos.x,vp_pos.y].used=false)
      then result:=true
      else result:=false;
  end; // function pconnectpossible(vp_pos:r_koordinaten):boolean;

  procedure pconnect(vp_pos: tpoint);
  var
    vp_srcpos: tpoint;
  begin

    // Feld links
    vp_srcpos:=vp_pos;
    vp_srcpos.x:=vp_srcpos.x-1;
    if pconnectpossible(vp_srcpos) then connect(vp_srcpos,vp_pos);

    // Feld rechts
    vp_srcpos.x:=vp_srcpos.x+2;
    if pconnectpossible(vp_srcpos) then connect(vp_srcpos,vp_pos);

    // Feld oben oder unten
    if getorient(vp_pos)=1 then
      //Feld oben
      begin
        vp_srcpos:=vp_pos;
        vp_srcpos.y:=vp_srcpos.y-1;
        if pconnectpossible(vp_srcpos) then connect(vp_srcpos,vp_pos);
      end
    else
      //Feld unten
      begin
        vp_srcpos:=vp_pos;
        vp_srcpos.y:=vp_srcpos.y+1;
        if pconnectpossible(vp_srcpos) then connect(vp_srcpos,vp_pos);
      end
  end;

var
  vp_unused, vp_xrun, vp_yrun: integer;
begin
  // Alle Felder auf unbenutzt zurcksetzten
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      begin
        v_data[vp_xrun,vp_yrun].used:=false;
      end;

  v_data[v_ablaufx,v_ablaufy].used:=true;

  repeat
    vp_unused:=0;
    for vp_yrun:= 1 to c_ywide do
      for vp_xrun:= 1 to c_xwide do
        if v_data[vp_xrun,vp_yrun].used
          then pconnect(point(vp_xrun,vp_yrun))
          else inc(vp_unused);
  until vp_unused<=1;

end;

procedure TForm1.b_bruteforceClick(Sender: TObject);
var

  vp_lowdisp:real;
  vp_lowdata:r_feld;
  vp_lowdispcount: integer;

  vp_time, vp_timekreis:integer;

  function spacer(vp_wide:integer):string;
  var
    vp_run:integer;
    vp_string:string;
  begin
    vp_string:='';
    for vp_run := 0 to vp_wide do vp_string:=vp_string+' ';
    result := vp_string;
  end;

  procedure p_next(vp_oldpos:tpoint;vp_depth:integer);
  var
    vp_newpos, vp_srcpos:tpoint;
    vp_Actdisp: real;
    vp_kreis:boolean;
  begin
    vp_depth:=vp_depth+1;
    // Nchsten Punkt bestimmen
    vp_newpos:=vp_oldpos;
    vP_newpos.x:=vp_newpos.x+1;
    if vp_newpos.x>c_xwide
    then
      begin
        vp_newpos.x:=1;
        vp_newpos.y:=vp_newpos.y+1;
      end;

    // berprfung ob noch nicht alle Felder bearbeitet wurden
    if (vp_newpos.y<=c_ywide)
    then
      begin
        if (vp_newpos.x<>v_ablaufx)or(vp_newpos.y<>v_ablaufy)
        then
          begin
            // 1. Mglichkeit: Ablauf nach oben
            vp_srcpos.x:=vp_newpos.x;
            vp_srcpos.y:=vp_newpos.y-1;
            if (vp_newpos.y>1)and                               // Feld liegt nicht in der obersten Reihe
               (getorient(vp_newpos)=1)and                      // Feld hat oben keine Spitze
               ((v_data[vp_srcpos.x,vp_srcpos.y].x<>vp_newpos.x)or
               (v_data[vp_srcpos.x,vp_srcpos.y].y<>vp_newpos.y)) // Feld wird nicht durch das andere Feld bewssert
            then
              begin
//                m_debug.lines.Add(spacer(vp_depth)+'  Feld '+inttostr(vp_newpos.x)+'; '+inttostr(vp_newpos.y)+' nach oben.');
                connect(vp_newpos,vp_srcpos);
                p_next(vp_newpos,vp_depth);
                connect(vp_newpos,point(-1,-1));
              end;

            // 2. Mglichkeit: Ablauf nach unten
            vp_srcpos.x:=vp_newpos.x;
            vp_srcpos.y:=vp_newpos.y+1;
            if (vp_newpos.y<c_ywide)and                         // Feld liegt nicht in der untersten Reihe
               (getorient(vp_newpos)=0)and                      // Feld hat unten keine Spitze
               ((v_data[vp_srcpos.x,vp_srcpos.y].x<>vp_newpos.x)or
               (v_data[vp_srcpos.x,vp_srcpos.y].y<>vp_newpos.y)) // Feld wird nicht durch das andere Feld bewssert
            then
              begin
//                m_debug.lines.Add(spacer(vp_depth)+'  Feld '+inttostr(vp_newpos.x)+'; '+inttostr(vp_newpos.y)+' nach unten.');
                connect(vp_newpos,vp_srcpos);
                p_next(vp_newpos,vp_depth);
                connect(vp_newpos,point(-1,-1));
              end;

            // 3. Mglichkeit: Ablauf nach links
            vp_srcpos.x:=vp_newpos.x-1;
            vp_srcpos.y:=vp_newpos.y;

            if (vp_newpos.x>1)and                               // Feld liegt nicht in der Spalte ganz links
               ((v_data[vp_srcpos.x,vp_srcpos.y].x<>vp_newpos.x)or
               (v_data[vp_srcpos.x,vp_srcpos.y].y<>vp_newpos.y)) // Feld wird nicht durch das andere Feld bewssert
            then
              begin
//                m_debug.lines.Add(spacer(vp_depth)+'  Feld '+inttostr(vp_newpos.x)+'; '+inttostr(vp_newpos.y)+' nach links.');
                connect(vp_newpos,vp_srcpos);
                p_next(vp_newpos,vp_depth);
                connect(vp_newpos,point(-1,-1));
              end;

            // 4. Mglichkeit: Ablauf nach rechts
            vp_srcpos.x:=vp_newpos.x+1;
            vp_srcpos.y:=vp_newpos.y;
            if (vp_newpos.x<c_xwide)and                         // Feld liegt nicht in der Spalte ganz rechts
               ((v_data[vp_srcpos.x,vp_srcpos.y].x<>vp_newpos.x)or
               (v_data[vp_srcpos.x,vp_srcpos.y].y<>vp_newpos.y)) // Feld wird nicht durch das andere Feld bewssert
            then
              begin
//                m_debug.lines.Add(spacer(vp_depth)+'  Feld '+inttostr(vp_newpos.x)+'; '+inttostr(vp_newpos.y)+' nach rechts.');
                connect(vp_newpos,vp_srcpos);
                p_next(vp_newpos,vp_depth);
                connect(vp_newpos,point(-1,-1));
              end;
          end // if (vp_newpos.x<>v_ablaufx)or(vp_newpos.y<>v_ablaufy)
        else
          begin
            p_next(vp_newpos,vp_depth);
          end;
      end // if ((vp_newpos.x<c_xwide)and(vp_newpos.y>c_ywide))
    else
    begin
      ut_start;
      vp_kreis:=allconnected;
      vp_timekreis:=vp_timekreis+ut_stop;
      if vp_kreis
      then
        begin // Alle Felder sind verbunden und es gibt keine Kreislufe
          if cb_show.checked
          then
            begin
              b_showpipesclick(sender);
              b_flussclick(sender);
            end;

          vp_actdisp:=calcdisp;

//          m_debug.lines.Add('Fertig ('+floattostr(vp_actdisp)+'; '+floattostr(vp_actdisp-vp_lowdisp)+')');

          if vp_lowdisp=-1 // erste Lsung
          then
            begin
              vp_lowdisp:=vp_actdisp;
              vp_lowdata:=v_data;
              vp_lowdispcount:=1;
            end
          else  // weitere Lsung
            if vp_actdisp<vp_lowdisp
            then
              begin
                vp_lowdisp:=vp_actdisp;
                vp_lowdata:=v_data;
                vp_lowdispcount:=1;
//                m_debug.lines.Add('Besser ('+floattostr(vp_lowdisp)+')');
              end
            else
              if vp_actdisp=vp_lowdisp
              then
                begin
                  inc(vp_lowdispcount);
//                  m_debug.lines.Add('Gleich gut ('+floattostr(vp_lowdisp)+')');
                end;
          if cb_wait.checked
          then showmessage('Ende erreicht');
        end;
    end;
  end;

var
  vp_startpos: tpoint;
  vp_xrun, vp_yrun: integer;
  vp_max: real;

begin
  m_debug.Lines.Clear;
  m_debug.Lines.Add('Brute Force');

  // Anzahl der maximal mglichen Kombinationen wird bestimmt
  vp_max:=3;
  for vp_xrun := 3 to c_xwide*c_ywide do vp_max:= vp_max*3;
  m_debug.Lines.Add(floattostr(vp_max)+' mgliche Kombinationen werden untersucht');

  // Alle Felder auf unbenutzt zurcksetzten
  for vp_yrun:= 1 to c_ywide do
    for vp_xrun:= 1 to c_xwide do
      begin
        v_data[vp_xrun,vp_yrun].x:=-1;
        v_data[vp_xrun,vp_yrun].y:=-1;
      end;
  vp_lowdisp:=-1;

  vp_timekreis:=0;
  vp_time:=ut_now;
  vp_startpos.x:=0;
  vp_startpos.y:=1;
  p_next(vp_startpos,0);

  vp_time:=ut_now-vp_time;
  // Ergebnis anzeigen
  m_debug.Lines.Add('');
  m_debug.Lines.Add('Bester Disp.: '+floattostr(vp_lowdisp)+' ('+inttostr(vp_lowdispcount)+' mal vorhanden)');
  m_debug.Lines.Add('Gesamtzeit: '+inttostr(vp_time));
  m_debug.Lines.Add('Kreiszeit: '+inttostr(vp_timekreis));
  v_data:=vp_lowdata;
  b_showpipesclick(sender);
  b_flussclick(sender);

  showmessage('Dispersionsrate: '+floattostr(vp_lowdisp));
end;

end.
